/*
Class that convers Belarusian text to/from kyrylica and lacinka

Copyright (C) 2000  Alexander Mikhailian (mikhailian@altern.org)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef convertH
#define convertH

#ifndef __GNUC__ 
#define STRICT
#define WIN32_LEAN_AND_MEAN
#endif

/////////////////////////////////////////////////////////////////////////////
// Cross-compilation - should be moved to a separate file soon
// STLport support - does not work - will be removed soon
#ifdef __GNUC__ 
	#define __STD__ _STL
	//template wchar_t* string_char_traits<wchar_t>::move(wchar_t *, wchar_t const *, unsigned int);
	//template wchar_t* string_char_traits<wchar_t>::copy(wchar_t *, wchar_t const *, unsigned int);
#else 
	#define __STD__ std
#endif
// End cross-compilation
//////////////////////////////////////////////////////////////////

#include <string>

using namespace __STD__;

// GCC wstring problem not solved
//#ifdef __GNUC__
//template wchar_t* string_char_traits<wchar_t>::move(wchar_t *, wchar_t const *, unsigned int);
//template wchar_t* string_char_traits<wchar_t>::copy(wchar_t *, wchar_t const *, unsigned int);
//typedef basic_string <wchar_t> wstring;
//#endif

//NB! NB!                                            
//If you're using mingw32 prior to version 2.95 then you have to uncomment the
//following #ifdef __GNUC__ ... #endif block

/*#ifdef __GNUC__

#ifdef __cplusplus
extern "C"
{
#endif

typedef struct _NOTIFYICONDATAA {
        DWORD cbSize;
        HWND hWnd;
        UINT uID;
        UINT uFlags;
        UINT uCallbackMessage;
        HICON hIcon;
        CHAR   szTip[64];
} NOTIFYICONDATAA, *PNOTIFYICONDATAA;
typedef struct _NOTIFYICONDATAW {
        DWORD cbSize;
        HWND hWnd;
        UINT uID;
        UINT uFlags;
        UINT uCallbackMessage;
        HICON hIcon;
        WCHAR  szTip[64];
} NOTIFYICONDATAW, *PNOTIFYICONDATAW;
#ifdef UNICODE
typedef NOTIFYICONDATAW NOTIFYICONDATA;
typedef PNOTIFYICONDATAW PNOTIFYICONDATA;
#else
typedef NOTIFYICONDATAA NOTIFYICONDATA;
typedef PNOTIFYICONDATAA PNOTIFYICONDATA;
#endif // UNICODE

#define NIM_ADD         0x00000000
#define NIM_MODIFY      0x00000001
#define NIM_DELETE      0x00000002

#define NIF_MESSAGE     0x00000001
#define NIF_ICON        0x00000002
#define NIF_TIP         0x00000004

BOOL WINAPI Shell_NotifyIconA(DWORD dwMessage, PNOTIFYICONDATAA lpData);
BOOL WINAPI Shell_NotifyIconW(DWORD dwMessage, PNOTIFYICONDATAW lpData);
#ifdef UNICODE
#define Shell_NotifyIcon  Shell_NotifyIconW
#else
#define Shell_NotifyIcon  Shell_NotifyIconA
#endif // !UNICODE

#ifdef __cplusplus
}
#endif

#endif //end GNU specific */

class CConvert
{
public:
	CConvert(void);  //default constructor
	void C2T(wchar_t* wbuffer, int wbuflen);
	void C2L(wchar_t* wbuffer, int wbuflen);
	void L2C(wchar_t* wbuffer, int wbuflen);
	~CConvert(void); //destructor
private:
	wchar_t a_cyr_lcase[35];
	wchar_t a_cyr_ucase[35];

	wchar_t a_lat_lcase[31];
	wchar_t a_lat_ucase[31];

	wchar_t a_lat_lvow[6];

	wchar_t a_cyr_lhrdcontxt[35];
	wchar_t a_cyr_uhrdcontxt[35]; 

	__STD__::wstring wstr;

	bool b_cyr_hrdcontxt;
	bool blcase;
	bool blvow;
	
	const wchar_t* wSource;
	wchar_t* wDestination;
	
	unsigned int i, x;
};

#endif
